## ros-indigo-ros-web-video 0.1.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ros_web_video)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED roscpp rostime sensor_msgs image_transport mk) 
find_package(Boost COMPONENTS system filesystem thread REQUIRED)
find_package(BZip2 REQUIRED)
find_package(ZLIB REQUIRED)

###################################################
## Declare things to be passed to other projects ##
###################################################

## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME} 
  CATKIN_DEPENDS sensor_msgs image_transport roscpp rostime mk
)

###########
## Build ##
###########

## Specify additional locations of header files
include_directories(include
  ${PROJECT_SOURCE_DIR}/FFmpeg/
  ${catkin_INCLUDE_DIRS} 
  ${Boost_INCLUDE_DIRS}
  ${ZLIB_INCLUDE_DIRS}
  ${BZIP2_INCLUDE_DIR}
)

link_directories(
  ${catkin_LIBRARY_DIRS}
  ${Boost_LIBRARY_DIRS}
  ${ZLIB_LIBRARY_DIRS}
  ${BZIP2_LIBRARY_DIR}
)

add_definitions(
  ${ZLIB_CFLAGS_OTHER}
  ${BZIP2_CFLAGS_OTHER}
)

## Grab external libraries
execute_process(
  COMMAND git config --global http.sslVerify false
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/
)
execute_process(
  COMMAND git clone https://chromium.googlesource.com/webm/libvpx
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/
)
execute_process(
  COMMAND git checkout v1.2.0
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/libvpx
)
execute_process(
  COMMAND git clone https://github.com/FFmpeg/FFmpeg.git
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/
)
execute_process(
  COMMAND git checkout n1.1
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/FFmpeg
)
execute_process(
  COMMAND git config --global http.sslVerify true
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/
)

## Setup libvpx
execute_process(
  COMMAND ./configure --enable-vp8
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/libvpx/
)
execute_process(
  COMMAND make
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/libvpx/
)

## Setup FFmpeg
execute_process(
  COMMAND ./configure --enable-libvpx --extra-cflags="-I../libvpx" --extra-ldflags="-L../libvpx" --enable-gpl
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/FFmpeg/
)
execute_process(
  COMMAND make WORKING_DIRECTORY
  ${PROJECT_SOURCE_DIR}/FFmpeg/
)

## Declare a cpp executables and libraries
add_executable(${PROJECT_NAME}
  src/ffmpeg_wrapper.cpp 
  src/server.cpp
  src/connection.cpp
  src/topic_streamer.cpp
  src/reply.cpp
  src/request_parser.cpp
  src/image_subscriber.cpp
  src/ffmpeg_encoder.cpp
)

add_library(avcodec STATIC IMPORTED)
set_property(TARGET avcodec
  PROPERTY IMPORTED_LOCATION ${PROJECT_SOURCE_DIR}/FFmpeg/libavcodec/libavcodec.a
)

add_library(avformat STATIC IMPORTED)
set_property(TARGET avformat PROPERTY
  IMPORTED_LOCATION ${PROJECT_SOURCE_DIR}/FFmpeg/libavformat/libavformat.a
)
           
add_library(avutil STATIC IMPORTED)  
set_property(TARGET avutil PROPERTY
  IMPORTED_LOCATION ${PROJECT_SOURCE_DIR}/FFmpeg/libavutil/libavutil.a
)

add_library(avfilter STATIC IMPORTED)  
set_property(TARGET avfilter PROPERTY
  IMPORTED_LOCATION ${PROJECT_SOURCE_DIR}/FFmpeg/libavfilter/libavfilter.a
)
             
add_library(swscale STATIC IMPORTED)  
set_property(TARGET swscale PROPERTY
  IMPORTED_LOCATION ${PROJECT_SOURCE_DIR}/FFmpeg/libswscale/libswscale.a
)
             
add_library(vpx STATIC IMPORTED)  
set_property(TARGET vpx PROPERTY
  IMPORTED_LOCATION ${PROJECT_SOURCE_DIR}/libvpx/libvpx.a
)

target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  avcodec
  avformat
  avutil
  avfilter
  swscale
  vpx
  ${BZIP2_LIBRARIES}
  ${ZLIB_LIBRARIES}
)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME} 
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

install(DIRECTORY include/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

=== debian/changelog ===
ros-indigo-ros-web-video (0.1.14-0trusty) trusty; urgency=high

  * DEPRECATION NOTICE
  * Contributors: Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Thu, 30 Oct 2014 04:00:00 -0000

ros-indigo-ros-web-video (0.1.13-0trusty) trusty; urgency=high

  * Merge pull request #6 from mitchellwills/develop
    Fix ros_web_video  HTTP header generation
  * Fixed ROS_INFO argument mismatch
  * Fixed HTTP Header generation
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Wed, 08 Oct 2014 04:00:00 -0000

ros-indigo-ros-web-video (0.1.12-0trusty) trusty; urgency=high

  * travis speed fix
  * resets SSL flag in cmake
  * travis updated to remove external gits
  * Contributors: Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Mon, 21 Apr 2014 04:00:00 -0000

ros-indigo-ros-web-video (0.1.11-0trusty) trusty; urgency=high

  * CA-cert fix
  * Contributors: Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Fri, 18 Apr 2014 04:00:00 -0000

ros-indigo-ros-web-video (0.1.10-0trusty) trusty; urgency=high

  * ignores downloads
  * Remove submodule entry
  * modules removed
  * submodules being weird
  * Contributors: Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Thu, 17 Apr 2014 04:00:00 -0000

ros-indigo-ros-web-video (0.1.9-0trusty) trusty; urgency=high

  * build now downloads deps
  * Contributors: Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Thu, 17 Apr 2014 04:00:00 -0000

ros-indigo-ros-web-video (0.1.8-0trusty) trusty; urgency=high

  * submodule now in correct directory
  * travis now runs hydro and groovy and submodules now initilized in build
  * Contributors: Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Thu, 17 Apr 2014 04:00:00 -0000

ros-indigo-ros-web-video (0.1.7-0trusty) trusty; urgency=high

  * submodule moved to HTTPS
  * git submodules now used instead of willow servers for ffmpeg
  * v1.2.0 libvpx
  * libvpx added
  * moved to submodule
  * cmake cleanup
  * basic cleanup
  * adding travis.yml
  * adding travis.yml
  * Contributors: Julius Kammerl, Russell Toris

 -- Russell Toris <rctoris@wpi.edu>  Wed, 16 Apr 2014 04:00:00 -0000

ros-indigo-ros-web-video (0.1.6-0trusty) trusty; urgency=high

  * 0.1.5 -> 0.1.6
  * adding switch to disable file serving
  * adding file_server ros parameter
  * package.xml
  * renaming project to ros_web_video
  * Contributors: Julius Kammerl

 -- Russell Toris <rctoris@wpi.edu>  Thu, 16 May 2013 04:00:00 -0000

ros-indigo-ros-web-video (0.1.5-0trusty) trusty; urgency=high

  * 0.1.4 -> 0.1.5
  * patching "codec not found" crash
  * Contributors: Julius Kammerl

 -- Russell Toris <rctoris@wpi.edu>  Mon, 22 Apr 2013 04:00:00 -0000

ros-indigo-ros-web-video (0.1.4-0trusty) trusty; urgency=high

  * 0.1.3 -> 0.1.4
  * patching ffmpeg bug
  * Contributors: Julius Kammerl

 -- Russell Toris <rctoris@wpi.edu>  Wed, 17 Apr 2013 04:00:00 -0000

ros-indigo-ros-web-video (0.1.3-0trusty) trusty; urgency=high

  * 0.1.2 -> 0.1.3
  * adding download_checkmd5.py to 3rdparty
  * Contributors: Julius Kammerl

 -- Russell Toris <rctoris@wpi.edu>  Fri, 15 Feb 2013 05:00:00 -0000

ros-indigo-ros-web-video (0.1.2-0trusty) trusty; urgency=high

  * 0.1.1 -> 0.1.2
  * adding mk package dependency
  * Contributors: Julius Kammerl

 -- Russell Toris <rctoris@wpi.edu>  Thu, 14 Feb 2013 21:23:00 -0000

ros-indigo-ros-web-video (0.1.1-0trusty) trusty; urgency=high

  * version 0.1.1
  * integrating download_unpack_build.mk
  * Contributors: Julius Kammerl

 -- Russell Toris <rctoris@wpi.edu>  Thu, 14 Feb 2013 19:21:00 -0000

ros-indigo-ros-web-video (0.1.0-0trusty) trusty; urgency=high

  * version 0.1.0
  * adding download script to 3rdparty dir
  * Removed the '?' prefix requirement for URLs
  * making http headers optional
  * removing depthcloud proof-of-concept code
  * removed bad bzip2 dependecy
  * adding missing bzip2 dependency
  * more catkinization
  * adding zlib dependency to CMakeLists.txt and package.xml
  * Merge branch 'groovy-devel' of github.com:RobotWebTools/ros_http_video_streamer into groovy-devel
  * adding zlib to package.xml
  * minor.. added comments
  * adding MIME types for css and javascript files
  * fixing wwwroot bug
  * adding debug output to web file server
  * renaming webGL_pointcloud_image_encoder in CMakeList
  * renaming web_gl pointlcoud converter node
  * switching to local rosparam nodehandle + additional debug output
  * Merge pull request #2 <https://github.com/RobotWebTools/ros_web_video/issues/2> from jon-weisz/cmake_fixcmake-fix-for-3rdparty
    fixed 3rdparty library build problem in ros_http_video_streamer by expli...
  * fixed 3rdparty library build problem in ros_http_video_streamer by explicitly executing the make command in CMakeLists.txt
  * more ffmpeg tuning
  * adding rosparam parameter in order to define the ROS image transport
  * adding filter in order to remove raw image topics from topic list
  * fixed encoding <-> data transmission synchronization
  * adding additional parameters to server configuration
  * adding roscpp and rostime deps
  * catkinizing image streamer
  * Adding 3rdparty checkout&compilation to CMake
  * Merge pull request #1 <https://github.com/RobotWebTools/ros_web_video/issues/1> from KaijenHsiao/master
    added rosdep for yasm
  * added rosdep for yasm
  * adding mutex lock manager
  * adding additional mutext to protect av_open/av_close
  * explicit ffmpeg_wrapper shutdown
  * adding ROS makefile
  * cleanup
  * restructured javascript code
  * ffmepg initialization startup protection
  * transfercoding header fix
  * minor
  * shared pointers seem to be reused in openni_launch
  * more thread security
  * more mleak fixing
  * fixing memory leak
  * switching back to image transport
  * moving OrbitControls.js to js folder
  * Adding orbit control to webgl pointcloud viewer
  * unsubscribe from image topics in deconstructor
  * Merge branch 'master' of github.com:ros-interactive-manipulation/ros_http_video_streamer


=== debian/control ===
Source: ros-indigo-ros-web-video
Section: misc
Priority: extra
Maintainer: Russell Toris <rctoris@wpi.edu>
Build-Depends: debhelper (>= 9.0.0), git-core, libbz2-dev, ros-indigo-catkin, ros-indigo-image-transport, ros-indigo-mk, ros-indigo-roscpp, ros-indigo-rostime, ros-indigo-sensor-msgs, yasm, zlib1g-dev
Homepage: http://wiki.ros.org/ros_web_video
Standards-Version: 3.9.2

Package: ros-indigo-ros-web-video
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbz2-dev, ros-indigo-image-transport, ros-indigo-mk, ros-indigo-roscpp, ros-indigo-rostime, ros-indigo-sensor-msgs, zlib1g-dev
Description: Streaming of ROS Image Topics via HTTP

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-ros-web-video//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
